(function ($) {

Drupal.behaviors.pendingUser = {
  attach: function (context, settings) {
    // Append js to approve/reject links so menu callback knows if JS enabled.
    $(".pendinguser-approve-reject a").attr("href", function(i, href) {
      var href_parts = href.split('?');
      return href_parts[0] + '/js?' + href_parts[1];
    });
    $('#pendinguser-approve').pendinguserProcess();
    $('#pendinguser-reject').pendinguserProcess();
  }
};

$.fn.pendinguserProcess = function(context, settings) {
  context = context || document;
  settings = settings || Drupal.settings;
  /* See http://addictedtonew.com/archives/414/creating-a-jquery-plugin-from-scratch/ */
  return this.each(function() {
    $(this).click( function(a) {
      a.preventDefault();
      /* If we've marked this link disabled, don't allow anything. */
      if ($(atag).hasClass('disabled')) {return;}
      /* Toggle the disabled class.  CSS disables button and uses wait cursor. */
      pendinguserButtonsToggle(true);
      var atag = $(this);
      $.ajax({
        url: atag.attr('href'),
        type: "GET",
        success: function(response) {
          $('#pendinguser-messages').hide().append('<p>' + response + '</p>').show('slow');
          pendinguserButtonsToggle(false);
          var i = $('#pendinguser-index').html();
          var count = $('#pendinguser-count').html();
          if (parseInt(i) < parseInt(count)) {
            $('#pendinguser-name').html(settings.pendinguserData[i]['name']);
            $('#pendinguser-mail').html(settings.pendinguserData[i]['mail']);
            $('#pendinguser-edit').html(settings.pendinguserData[i]['edit']);
            $('#pendinguser-index').html(parseInt(i) + 1);
            $("#pendinguser-approve").attr("href", function() {
              var href = settings.pendinguserData[i]['approve'];
              var href_parts = href.split('?');
              return href_parts[0] + '/js?' + href_parts[1];
            });
            $("#pendinguser-approve").attr("title", settings.pendinguserData[i]['approvetitle']);
            $("#pendinguser-reject").attr("href", function() {
              var href = settings.pendinguserData[i]['reject'];
              var href_parts = href.split('?');
              return href_parts[0] + '/js?' + href_parts[1];
            });
            $("#pendinguser-reject").attr("title", settings.pendinguserData[i]['rejecttitle']);
          }
          else {
            $('p.pendinguser-count, #block-pendinguser-approval dl, div.pendinguser-approve-reject').hide();
            $('p.pendinguser-count').html(Drupal.t('There are no more pending users.')).show('slow');
          }
        }
      })
    });
  });

  function pendinguserButtonsToggle(add) {
    $('#pendinguser-approve').toggleClass('disabled', add);
    $('#pendinguser-reject').toggleClass('disabled', add);
  }

};

})(jQuery);
